###############################################################################
#
# Copyright (C) 2006-2008 Red Hat, Inc. All rights reserved.
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License version 2.
#
###############################################################################


%define include_zope_and_plone	yes


############ SRPM ###################

Name: conga
Version: 0.11.2
Release: 4%{?dist}.2
License: GPL
URL: http://sources.redhat.com/cluster/conga

Group: System Environment/Base
Summary: Remote Management System

Source0: %{name}-%{version}.tar.gz
%if "%{include_zope_and_plone}" == "yes"
Source1: Zope-2.8.9.1-final.tgz
Source3: Five-1.2.6.tgz
Source2: Plone-2.5.5.tar.gz
Patch2: Plone-2.5.5-CMFPlone.patch
%endif
Patch3: bz536921.patch
Patch4: bz536921-2.patch
Patch5: bz680514.patch
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExcludeArch: ppc64
BuildRequires: python-devel >= 2.3.4
BuildRequires: glibc-devel gcc-c++ libxml2-devel sed
BuildRequires: cyrus-sasl-devel >= 2.1
BuildRequires: openssl-devel dbus-devel pkgconfig file

%description
Conga is a project developing management system for remote stations.
It consists of luci, https frontend, and ricci, secure daemon that dispatches
incoming messages to underlying management modules.

%prep
%setup -q
%if "%{include_zope_and_plone}" == "yes"
# Zope
%setup -q -T -D -a 1
ln -s ../Zope-2.8.9.1-final luci/zope
# Zope's Five
%setup -q -T -D -a 3
rm -rf luci/zope/lib/python/Products/Five
mv Five luci/zope/lib/python/Products/Five
# Plone
%setup -q -T -D -a 2
ln -s ../Plone-2.5.5 luci/plone
pushd luci/plone
%patch2 -p1
popd
%endif
%patch3 -p1 -b .536921
%patch4 -p1 -b .536921
%patch5 -p1

%build
%configure		--arch=%{_arch} \
		--docdir=%{_docdir} \
		--include_zope_and_plone=%{include_zope_and_plone}
make %{?_smp_mflags} conga

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install_conga

%clean
rm -rf $RPM_BUILD_ROOT


####### luci #######

%package -n luci

Group: System Environment/Base
Summary: Remote Management System - Management Station

Requires: chkconfig initscripts bc
Requires: python >= 2.3.4
%if "%{include_zope_and_plone}" == "yes"
Provides: config(luci) = %{version}-%{release}
# don't provide zope internals
AutoProv: no
%else
AutoProv: yes
Requires: zope
Requires: plone >= 2.5
%endif
Requires: grep openssl mailcap stunnel
Requires: sed util-linux

Requires(pre): grep shadow-utils
Requires(post): chkconfig initscripts
Requires(preun): chkconfig initscripts

%description -n luci
Conga is a project developing management system for remote stations.
It consists of luci, https frontend, and ricci, secure daemon that
dispatches incoming messages to underlying management modules.

This package contains the luci server.

%files -n luci
%verify(not size md5 mtime) /var/lib/luci/var/Data.fs
%verify(not size md5 mtime) /var/lib/luci/.default_password_has_been_reset
%defattr(-,root,root)
%config(noreplace)		%{_sysconfdir}/sysconfig/luci
				%{_sysconfdir}/rc.d/init.d/luci
				%{_sbindir}/luci_admin
				%{_docdir}/luci-%{version}/
%defattr(0755,root,root)
				%{_libdir}/luci/
%defattr(-,luci,luci)
				%{_localstatedir}/lib/luci
				%{_libdir}/luci/ssl
%if "%{include_zope_and_plone}" == "yes"
				%{_libdir}/luci/zope
%endif

%pre -n luci
groupmod luci >&/dev/null
if [ $? -eq 6 ]; then 
	/usr/sbin/groupadd -r -f luci >&/dev/null
fi

id luci >&/dev/null
if [ $? -ne 0 ]; then
	/usr/sbin/useradd -r -M -s /sbin/nologin -d /var/lib/luci -g luci luci >&/dev/null
fi

if [ $1 -gt 1 ]; then
	# Package upgrade
	/sbin/service luci status >&/dev/null
	LUCI_RUNNING=$?
	if [ $LUCI_RUNNING -eq 0 ]; then
		/sbin/service luci stop >& /dev/null
		# allow the zope machinery time to shut down
		sleep 4
	fi
	/usr/sbin/luci_admin backup >&/dev/null
	if [ $LUCI_RUNNING -eq 0 ]; then
		/sbin/service luci start >&/dev/null
	fi
fi
exit 0

%post -n luci
/sbin/chkconfig --add luci
/sbin/service luci status >&/dev/null
LUCI_RUNNING=$?
if [ $LUCI_RUNNING -eq 0 ]; then
	/sbin/service luci stop >&/dev/null
fi
if [ -f /var/lib/luci/var/luci_backup.xml ]; then
	# restore luci database
	/usr/sbin/luci_admin restore >&/dev/null
fi

# set initial admin password (if not already set) to random value
grep True /var/lib/luci/.default_password_has_been_reset >&/dev/null
if [ $? -ne 0 ]; then
	/usr/sbin/luci_admin password --random >&/dev/null &&
		rm -f /var/lib/luci/var/Data.fs.index /var/lib/luci/var/Data.fs.tmp /var/lib/luci/var/Data.fs.old >& /dev/null
	find %{_libdir}/luci/zope/var -print0 2>/dev/null | xargs -0 chown luci: >&/dev/null
fi
if [ $LUCI_RUNNING -eq 0 ]; then
	/sbin/service luci start >&/dev/null
fi
exit 0

%preun -n luci
if [ $1 -eq 0 ]; then
	# uninstall
	/sbin/service luci stop >&/dev/null
	/sbin/chkconfig --del luci

	/sbin/service luci status >&/dev/null
	LUCI_RUNNING=$?
	if [ $LUCI_RUNNING -eq 0 ]; then
		/sbin/service luci stop >&/dev/null
		# allow the zope machinery time to shut down
		sleep 4
	fi
	/usr/sbin/luci_admin backup >&/dev/null
fi
exit 0


### ricci daemon & basic modules ###

%package -n ricci

Group: System Environment/Base
Summary: Remote Management System - Managed Station

Requires: initscripts
Requires: oddjob dbus openssl pam cyrus-sasl >= 2.1
Requires: sed util-linux
Requires: modcluster >= 0.11.0

# modreboot

# modrpm

# modstorage
Requires: parted util-linux

# modservice
Requires: chkconfig initscripts

# modlog

Requires(pre): grep shadow-utils
Requires(post): chkconfig initscripts util-linux
Requires(preun): chkconfig initscripts
Requires(postun): initscripts util-linux

%description -n ricci
Conga is a project developing management system for remote stations.
It consists of luci, https frontend, and ricci, secure daemon that dispatches
incoming messages to underlying management modules.

This package contains listening daemon (dispatcher), as well as
reboot, rpm, storage, service and log management modules.

%files -n ricci
%defattr(-,root,root)
# ricci
%config(noreplace)	%{_sysconfdir}/pam.d/ricci
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci.systembus.conf
			%{_sysconfdir}/rc.d/init.d/ricci
%attr(-,ricci,ricci)	%{_localstatedir}/lib/ricci
			%{_sbindir}/ricci
%attr(-,root,ricci)	%{_libexecdir}/ricci/
			%{_docdir}/ricci-%{version}/
# modrpm
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modrpm.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modrpm.systembus.conf
			%{_libexecdir}/ricci-modrpm
# modstorage
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modstorage.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modstorage.systembus.conf
			%{_libexecdir}/ricci-modstorage
# modservice
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modservice.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modservice.systembus.conf
			%{_libexecdir}/ricci-modservice
# modlog
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modlog.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modlog.systembus.conf
			%{_libexecdir}/ricci-modlog

%pre -n ricci
if ! /bin/grep ^ricci\:x /etc/group >&/dev/null; then
	/usr/sbin/groupadd -r -f ricci >&/dev/null
fi
if ! /bin/grep ^ricci\:x /etc/passwd >&/dev/null; then
	/usr/sbin/useradd -r -M -s /sbin/nologin -d /var/lib/ricci -g ricci ricci >&/dev/null
fi
exit 0

%post -n ricci
DBUS_PID=`cat /var/run/messagebus.pid 2>/dev/null`
/bin/kill -s SIGHUP $DBUS_PID >&/dev/null
/sbin/service oddjobd reload >&/dev/null
/sbin/chkconfig --add ricci
exit 0

%preun -n ricci
if [ "$1" == "0" ]; then
	/sbin/service ricci stop >&/dev/null
	/sbin/chkconfig --del ricci
fi
exit 0

%postun -n ricci
if [ "$1" == "0" ]; then
	DBUS_PID=`cat /var/run/messagebus.pid 2>/dev/null`
	/bin/kill -s SIGHUP $DBUS_PID >&/dev/null
	/sbin/service oddjobd reload >&/dev/null
fi
if [ "$1" == "1" ]; then
	/sbin/service ricci condrestart >&/dev/null
fi
exit 0




###  changelog ###




%changelog
* Fri Mar 04 2011 Ryan McCabe <rmccabe@redhat.com> 0.11.2-4.2
- Fix bz680514 (CVE-2011-0720 plone: unauthorized remote administrative access)

* Fri Feb 25 2011 Ryan McCabe <rmccabe@redhat.com> 0.11.2-4.1
- Fix bz680514 (CVE-2011-0720 plone: unauthorized remote administrative access)

* Mon Jan 31 2011 Ryan McCabe <rmccabe@redhat.com> 0.11.2-4
- Additional fix for bz536921: make sure two_votes="1" is removed
  when adding a quorum disk to a two node cluster.

* Mon Oct 25 2010 Ryan McCabe <rmccabe@redhat.com> 0.11.2-3
- Fix bz536921 (Need to update expected_votes when adding a qdisk)

* Mon Apr 15 2009 Ryan McCabe <rmccabe@redhat.com> 0.11.2-2
- Fix bz494956 (Odd error display when creating a cluster)

* Mon Nov 25 2008 Ryan McCabe <rmccabe@redhat.com> 0.11.2-1
- Fix bz458298 (Cannot create new cluster in luci, python syntax error)
- Fix bz441583 (Don't allow both label and device for qdisk config if only one can be specified)
- Fix bz369131 (RFE: should only have to enter a system's password once)

* Mon May 12 2008 Ryan McCabe <rmccabe@redhat.com> 0.11.1-5
- Fix bz446082 (Adding multiple fence devices at the same time causes duplicate entries)
- Fix bz442729 (Add UI support for ssh for fence agents that now support it)

* Mon Apr 29 2008 Ryan McCabe <rmccabe@redhat.com> 0.11.1-4
- Fix bz444195 (conga writes 'exportpath' instead of 'export' attribute for netfs)

* Fri Apr 18 2008 Ryan McCabe <rmccabe@redhat.com> 0.11.1-3
- Fix bz442729 (Add UI support for ssh for fence agents that now support it)

* Tue Mar 25 2008 Ryan McCabe <rmccabe@redhat.com> 0.11.1-2
- Fix bz443002 (luci shows wrong state for 'Monitor link' checkbox in IP resource)
- Fix bz442933 (Luci inserts "hostname" instead of "ipaddr" for rsa II fencing device)
- Fix bz442369 (conga should install 'sg3_utils' and start service 'scsi_reserve' when scsi fencing is used)
- Fix bz441574 (nodename" field for fence_scsi disabled when adding a new fence device/instance)
- Fix bz349561 (Add Conga support for Oracle Resource Agent)
- Fix bz369131 (RFE: should only have to enter a system's password once)
- Fix bz333181 (Add option to not fail-back service)
- Fix bz295781 (RFE: add ability to set self_fence attribute for clusterfs resources)
- Fix bz253904 (Quorum disk page: Interval + tko should be together)
- Backport fixes from RHEL5

* Fri Oct 19 2007 Ryan McCabe <rmccabe@redhat.com> 0.11.0-3
- Fix bz340101 (Storage redirection after probe does not work on WinXP with FF2)
- Resolves: bz340101

* Wed Oct 16 2007 Ryan McCabe <rmccabe@redhat.com> 0.11.0-2
- Bump the version number to stay in sync with clustermon.
- Update the Zope database.

* Thu Sep 20 2007 Ryan McCabe <rmccabe@redhat.com> 0.11.0-1
- Merge in fixes from the RHEL5 code base.
- Fix bz238727 (Conga provides no way to remove a dead node from a cluster)
- Fix bz241414 (Installation using Conga shows "error" in message during reboot cycle.)
- Fix bz238656 (conga does not set the "nodename" attribute for manual fencing)
- Fix bz245200 (Conga needs to support Internet Explorer 6.0 and later)
- Fix bz227723 (Entering bad password when creating a new cluster = UnboundLocalError: local variable 'e' referenced before)
- Fix bz253905 (Quorum disk page: Minimum score does not need to be required)
- Fix bz253906 (Quorum disk page: Error when trying to continue w/o a heuristic)
- Fix bz253784
- Fix bz253901 (No node IDs generated on new RHEL4 / DLM cluster)
- Fix bz286951 (conga passes fence_scsi nodename, where as it accepts only node)
- Fix bz325501 (conga doesn't handle the cluster restart operation properly)
- Related: bz241417
- Resolves: bz238727, bz241414, bz238656, bz245200, bz227723
- Resolves: bz253905, bz253906, bz253784, bz253901, bz286951
- Resolves: bz325501

* Tue Apr 30 2007 Ryan McCabe <rmccabe@redhat.com> 0.9.1-9
- Fix bz238656 (conga does not set the "nodename" attribute for manual fencing)

* Tue Apr 30 2007 Ryan McCabe <rmccabe@redhat.com> 0.9.1-8
- Do not build for ppc64
- Resolves: bz236827

* Wed Apr 25 2007 Ryan McCabe <rmccabe@redhat.com> 0.9.1-7
- Fixed bz234196 (CVE-2007-0240 Conga includes version of Zope that is vulnerable to a XSS attack)
- Fixed bz237838 (modcluster and ricci scriptlets fail during install)
- Related: bz237838
- Resolves: bz234196

* Tue Mar 20 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.9.1-6
- Do not fail on i18n machines
- Fixed bz225747 (Create/delete cluster - then access disk on node = Generic error on host: cluster tools: cman_tool errored)
- Resolves: bz225747

* Tue Mar 20 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.9.1-5
- Fixed bz228637 (security alert - passwords sent back from server as input value)
- Fixed bz225558 (conga does not add fence_xvmd to cluster.conf)
- Fixed bz215014 (luci failover domain forms are missing/empty)
- Fixed bz225588 (luci web app does not enforce selection of fence port)
- Fixed bz225206 (Cluster cannot be deleted (from 'Manage Systems') - but no error results)
- Fixed bz213083 (should display usernames in some logical/sorted order)
- Fixed bz218964 (adding node to a cluster - confirm dialog displays cluster name in place of node name)
- Fixed bz222051 (Combining reauthentication/deletion options in one luci display can cause user confusion)
- Fixed bz225164 (Conga allows creation/rename of clusters with name greater than 15 characters)
- Fixed bz227723 (Entering bad password when creating a new cluster = UnboundLocalError: local variable 'e' referenced before assignment)
- Fixed bz223162 (Error trying to create a new fence device for a cluster node)
 - Resolves: bz228637, bz225558, bz215014, bz225588, bz225206
 - Resolves: bz213083, bz218964, bz222051, bz225164, bz227723
 - Resolves: bz223162

* Mon Feb 05 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.9.1-4
- Related: bz205522

* Sun Feb 04 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.9.1-3
- Fixed bz205522 (Web based Cluster Administration Interface)
- Resolves: bz205522

* Fri Dec 22 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.9.1-2
- luci storage: fix bytes->TB conversion
- Fixed bz201394 (luci doesn't verify ricci's SSL cert against trusted list)
- Fixed bz217387 (luci - HTML error shows up in display (minor))
- Fixed bz215031 (Cannot add a resource to a service via luci web app)
- Fixed bz218040 (luci reports "unknown" as cluster name if cluster creation fails)
- Fixed bz218941 (Conga/luci - cannot add node to cluster via luci web app)
- Fixed bz219156 (Errors in performing node-specific tasks due to ricci outage not reflected in luci display)
- Fixed bz217703 (clustered vg creation fails)
- Fixed bz214989 (Package download not working for Conga during cluster creation)
- Fixed bz219522 (Restarting a cluster via luci web gui = UnboundLocalError - local variable 'e' referenced before assignment)
- Fixed bz218040 (luci reports "unknown" as cluster name if cluster creation fails (not reproducible at will))
- Fixed bz212021 (various luci buttons do nothing)
- Fixed bz212448 (release blocker: turn off debug mode of server)
- Fixed bz212445 (release blocker: prevent management page access)

* Fri Nov 17 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.9.1-1
- Fixed bz212440 (luci persists possibly incorrect name for a system)
- Fixed bz215039 (Cannot create a new resource via luci web app)
- Fixed bz215034 (Cannot change daemon properties via luci web app)
- Fixed bz214790 (Stop/restart cluster not working via luci web app)
- Fixed bz213690 (luci - Reversed links in colophon (gui - minor))
- Fixed bz213266 (Conga - modifying a cluster node's cluster membership in a subnet with other clusters results in the wrong cluster.conf)
- Fixed bz213083 (luci - should display usernames in some logical/sorted order (usability))
- Fixed bz212601 (luci - selecting cluster name or cluster node name indicates error in install and displays empty form)
- Fixed bz212021 (various luci buttons do nothing)
- Fixed bz212006 (create cluster does not show status as cluster is being created)
- Fixed bz212584 (luci does not retrieve failed ricci queue elements)
- Improved bz213306 (ricci - log probing can take minutes to complete)
- Fixed starting/stopping services
- Fixed deleting cluster
- Fixed deleting node
- Fixed redirection for all async->busy wait calls
- Storage module: properly probe cluster quorum if LVM locking
  is marked as clustered

* Wed Nov 01 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-23
- 213504: luci does not correctly handle cluster.conf with
  nodes lacking FQDN

* Tue Oct 31 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-22
- 212582: SELinux prevents creation of /etc/cluster/cluster.conf

* Wed Oct 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-21
- 211564: ricci allocates huge memory chunk, causing long swapping
- 211345: cluster_adapters is missing import of Xenvm module
- 211191: SELinux issues tracking bug
- 211370: retrieving log from node fails
- 211942: Xenvm moniker must be eradicated from UI
- 211375: unable to reliably create a cluster
- 211373: reboot node fails from storage tab

* Wed Oct 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-20
- Minor GUI nits

* Wed Oct 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-19
- GUI nits
- Fixed bzs: 206663, 206567, 206571, 206572

* Wed Oct 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-18
- Version bump

* Wed Oct 04 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-17
- Many luci improvements

* Mon Sep 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-16
- Enable zope/plone inclusion on RHELs
- Remove luci's dependency on ricci
- Many improvements of cluster management interface
- Add full GFS1/2 support; detect many other filesystems
- Suppress msgs from init script (bz204235)
- Upgrade zope to 2.9.4 (track Fedora Core)

* Thu Aug 24 2006 Paul Nasrat <pnasrat@redhat.com> 0.8-15
- Disable inclusion of plone/zope and comment out requires

* Fri Aug 21 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-14
- Version bump

* Fri Aug 18 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-13
- Version bump

* Fri Aug 18 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-12
- Don't auto-start ricci after installation, do it manually
- Under certain circumstances, default luci password would not get reset
- Many Luci improvements

* Wed Aug 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-11.7
- Move ricci-modrpm, ricci-modlog, ricci-modstorage, ricci-modservice
   from /usr/sbin to /usr/libexec

* Wed Aug 09 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-11
- Spin off clustermon.srpm (modcluster, cluster-snmp and
   cluster-cim) from conga.srpm
- Luci: tighten down security

* Thu Aug 03 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-10
- Luci: fix login issues, add cluster resources, styling...

* Wed Jul 26 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-9
- Update Luci to Plone 2.5

* Tue Jul 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-8
- New build with a lot of implementation details on Luci
- Last build with plone 2.1.2

* Thu Jul 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-7
- More compliant specfile, minor fixes

* Tue Jun 27 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-6
- Luci persists users/clusters/systems/permissions across upgrades

* Fri Jun 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-4
- Moved storage, service, log and rpm modules into main ricci.rpm

* Wed Jun 14 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-1
- Packaged cluster-snmp (cluster snmp agent)
- Packaged cluster-cim (cluster CIM provider)

* Mon Jun 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.7-5
- Disable non-https access to Luci, enable https on port 8084

* Mon Jun 02 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.7-1
- Packaged Luci - ricci's www frontend
- Added logging module

* Mon May 26 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.6-1
- Multitude of fixes and new features

* Mon Apr 10 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.5-1
- First official build of conga project
